Index: ruby/branches/0.5/lib/open_ehr/rm.rb
===================================================================
--- ruby/branches/0.5/lib/open_ehr/rm.rb	(revision 174)
+++ 	(revision )
@@ -1,53 +1,0 @@
-$:.unshift File.join(File.dirname(__FILE__))
-# component: openEHR Ruby reference implementation
-# description: This file contains rm.packages.domain classes
-# keywords: archetype
-# author: Shinji KOBAYASHI, Akimichi TATSUKAWA
-# support: openEHR.jp
-# license: openEHR open source license
-#
-
-# OpenEHR::RM
-module OpenEhr
-
-  autoload :Assumed_Library_Types, "assumed_library_types.rb"
-
-  module RM
-    autoload :Demographic, "rm/demographic.rb"
-    autoload :Security, "rm/security.rb"
-
-    module Common
-      autoload :Resource, "rm/common/resource.rb"
-      autoload :Archetyped, "rm/common/archetyped.rb"
-      autoload :Generic, "rm/common/generic.rb"
-      autoload :Directory, "rm/common/directory.rb"
-      autoload :Change_Control, "rm/common/change_control.rb"
-    end
-
-    module Support
-      autoload :Definition, "rm/support/definition.rb"
-      autoload :Identification, "rm/support/identification.rb"
-      autoload :Terminology, "rm/support/terminology.rb"
-    end
-
-    module DataTypes
-      autoload :Basic, "rm/data_types/basic.rb"
-      autoload :Text, "rm/data_types/text.rb"
-      autoload :URI, "rm/data_types/uri.rb"
-      autoload :Quantity, "rm/data_types/quantity.rb"
-      autoload :Encapsulated, "rm/data_types/encapsulated.rb"
-      autoload :Time_Specification, 'rm/data_types/time_specification.rb'
-    end
-
-    module DataStructures
-      autoload :Data_Structure, "rm/data_structure.rb"
-      autoload :History, 'rm/data_structures/history.rb'
-      autoload :Item_Structure, 'rm/data_structures/item_structure.rb'
-    end
-
-    module Security
-      autoload :Security, 'rm/security.rb'
-    end
-  end
-
-end
Index: ruby/branches/0.5/lib/open_ehr/rm/data_structure.rb
===================================================================
--- ruby/branches/0.5/lib/open_ehr/rm/data_structure.rb	(revision 174)
+++ 	(revision )
@@ -1,20 +1,0 @@
-# rm::data_structures
-# class DATA_STRUCTURE
-# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_5_1_76d0249_1140447518205_872539_864Report.html
-# refs #59
-
-module OpenEhr
-  module RM
-    module DataStructures
-      class DataStructure < OpenEhr::RM::Common::Archetyped::Locatable
-        def initialize(args = { })
-          super(args)
-        end
-
-        def as_hierarchy
-          raise NotImplementedError, "as_hirarchy must be implemented"
-        end
-      end
-    end # of Data_Structures
-  end # of RM
-end # of OpenEHR
Index: ruby/branches/0.5/lib/open_ehr/rm/data_structures.rb
===================================================================
--- ruby/branches/0.5/lib/open_ehr/rm/data_structures.rb	(revision 175)
+++ ruby/branches/0.5/lib/open_ehr/rm/data_structures.rb	(revision 175)
@@ -0,0 +1,20 @@
+# rm::data_structures
+# class DATA_STRUCTURE
+# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_5_1_76d0249_1140447518205_872539_864Report.html
+# refs #59
+
+module OpenEhr
+  module RM
+    module DataStructures
+      class DataStructure < OpenEhr::RM::Common::Archetyped::Locatable
+        def initialize(args = { })
+          super(args)
+        end
+
+        def as_hierarchy
+          raise NotImplementedError, "as_hirarchy must be implemented"
+        end
+      end
+    end # of Data_Structures
+  end # of RM
+end # of OpenEHR
Index: ruby/branches/0.5/lib/open_ehr/rm/data_types/quantity.rb
===================================================================
--- ruby/branches/0.5/lib/open_ehr/rm/data_types/quantity.rb	(revision 174)
+++ ruby/branches/0.5/lib/open_ehr/rm/data_types/quantity.rb	(revision 175)
@@ -2,5 +2,5 @@
 # http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109599337877_94556_1510Report.html
 # Ticket refs #50
-require 'assumed_library_types'
+#require 'assumed_library_types'
 module OpenEhr
   module RM
@@ -8,5 +8,5 @@
       module Quantity
 
-        autoload :Date_Time, "rm/data_types/quantity/date_time.rb"
+#        autoload :Date_Time, "rm/data_types/quantity/date_time.rb"
 
         class DvOrdered < OpenEhr::RM::DataTypes::Basic::DataValue
Index: ruby/branches/0.5/lib/open_ehr/rm/data_types/quantity/date_time.rb
===================================================================
--- ruby/branches/0.5/lib/open_ehr/rm/data_types/quantity/date_time.rb	(revision 174)
+++ ruby/branches/0.5/lib/open_ehr/rm/data_types/quantity/date_time.rb	(revision 175)
@@ -2,5 +2,5 @@
 # http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109696321450_28117_5362Report.html
 # Ticket refs #49
-require 'assumed_library_types'
+#require 'assumed_library_types'
 require 'date'
 