Index: /ruby/branches/0.5/lib/open_ehr/rm/data_structures/item_structure/representation.rb
===================================================================
--- /ruby/branches/0.5/lib/open_ehr/rm/data_structures/item_structure/representation.rb	(revision 187)
+++ /ruby/branches/0.5/lib/open_ehr/rm/data_structures/item_structure/representation.rb	(revision 187)
@@ -0,0 +1,47 @@
+# rm::data_structures::representation
+# representation module
+# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109066789167_738055_2581Report.html
+# refs #53
+module OpenEhr
+  module RM
+    module DataStructures
+      module ItemStructure
+        module Representation
+          class Item < OpenEhr::RM::Common::Archetyped::Locatable
+            def initialize(args = {})
+              super(args)
+            end
+          end
+
+          class Element < Item
+            attr_accessor :value
+            attr_reader :null_flavor
+            def initialize(args = {})
+              super(args)
+              self.value = args[:value]
+              self.null_flavor= args[:null_flavor]
+            end
+
+            def null_flavor=(null_flavor)
+              sr = nil
+              if !null_flavor.nil? and
+                  null_flavor.defining_code.terminology_id.name == 'openehr'
+                sr = Terminology.find(:first,                                  
+                                      :conditions => "code = '#{null_flavor.defining_code.code_string}'")
+              end
+              if null_flavor.nil? or (!sr.nil? and sr.group == 'null flavours')
+                @null_flavor = null_flavor
+              else
+                raise ArgumentError, 'null_flavor is invalid'
+              end
+            end
+
+            def is_null?
+              return @value.nil?
+            end
+          end
+        end # of Representation
+      end # of ItemStructure
+    end # of DataStructures
+  end # of RM
+end # of OpenEhr
Index: by/branches/0.5/lib/open_ehr/rm/data_structures/representation.rb
===================================================================
--- /ruby/branches/0.5/lib/open_ehr/rm/data_structures/representation.rb	(revision 186)
+++ 	(revision )
@@ -1,45 +1,0 @@
-# rm::data_structures::representation
-# representation module
-# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109066789167_738055_2581Report.html
-# refs #53
-module OpenEhr
-  module RM
-    module DataStructures
-      module Representation
-        class Item < OpenEhr::RM::Common::Archetyped::Locatable
-          def initialize(args = {})
-            super(args)
-          end
-        end
-
-        class Element < Item
-          attr_accessor :value
-          attr_reader :null_flavor
-          def initialize(args = {})
-            super(args)
-            self.value = args[:value]
-            self.null_flavor= args[:null_flavor]
-          end
-
-          def null_flavor=(null_flavor)
-            sr = nil
-            if !null_flavor.nil? and
-                null_flavor.defining_code.terminology_id.name == 'openehr'
-              sr = Terminology.find(:first,                                  
-                                    :conditions => "code = '#{null_flavor.defining_code.code_string}'")
-            end
-            if null_flavor.nil? or (!sr.nil? and sr.group == 'null flavours')
-              @null_flavor = null_flavor
-            else
-              raise ArgumentError, 'null_flavor is invalid'
-            end
-          end
-
-          def is_null?
-            return @value.nil?
-          end
-        end
-      end # of Representation
-    end # of DataStructures
-  end # of RM
-end # of OpenEhr
Index: /ruby/branches/0.5/test/unit/lib/open_ehr/rm/data_structures/tc_representation.rb
===================================================================
--- /ruby/branches/0.5/test/unit/lib/open_ehr/rm/data_structures/tc_representation.rb	(revision 186)
+++ /ruby/branches/0.5/test/unit/lib/open_ehr/rm/data_structures/tc_representation.rb	(revision 187)
@@ -1,4 +1,4 @@
 # refs #53
-include OpenEhr::RM::DataStructures::Representation
+include OpenEhr::RM::DataStructures::ItemStructure::Representation
 include OpenEhr::RM::DataTypes::Text
 include OpenEhr::RM::Support::Identification